% ========================================================================
% Liang Xiong (lxiong[at]cs[dot]cmu[dot]edu), AutonLab, 2008-2013
%
% This piece of software is free for research purposes. 
% We hope it was helpful but do not privide any warranty.
% If you encountered any problems please contact the author.
% ========================================================================

function [ patches tblr ] = GetPatchFeature(img, xy, options)
%[ patches tblr ] = GetPatchFeature(img, xy, options)

if nargin < 3; options = []; end
[feature_size, patch_radius, show] = GetOptions(options,...
    'feature_size', [11 11], 'patch_radius', 5, 'show', false);

tblr = [xy(:,2) - patch_radius, xy(:,2) + patch_radius,...
    xy(:,1) - patch_radius, xy(:,1) + patch_radius]';
inbound = tblr(1,:) >= 1 & tblr(2,:) <= size(img,1) ...
    & tblr(3,:) >= 1 & tblr(4,:) <= size(img,2);
tblr = tblr(:,inbound);

patches = double(GetPatches(img, tblr, feature_size));
patches = reshape1(patches, [], size(tblr, 2));

if show
    imshow(AssemblePatches(patches', feature_size, tblr'));
end

% out of bound xy's are nan
patches = FillMat([], patches', inbound, 1);
tblr = FillMat([], tblr', inbound, 1);
