% ========================================================================
% Liang Xiong (lxiong[at]cs[dot]cmu[dot]edu), AutonLab, 2008-2013
%
% This piece of software is free for research purposes. 
% We hope it was helpful but do not privide any warranty.
% If you encountered any problems please contact the author.
% ========================================================================

function [patches] = GetPatches(img, tblr, feature_size)
% [patches] = GetPatches(img, tblr, feature_size)
% get patches from img given tblr, one column per patch

n = size(tblr, 2);
patches = nan([feature_size size(img,3) n]);
for ind = 1:n
    patch = img(tblr(1,ind):tblr(2,ind), tblr(3,ind):tblr(4,ind), :);
    patches(:,:,:,ind) = imresize(patch, feature_size);
end
patches = squeeze(patches);
