% ========================================================================
% Liang Xiong (lxiong[at]cs[dot]cmu[dot]edu), AutonLab, 2008-2013
%
% This piece of software is free for research purposes. 
% We hope it was helpful but do not privide any warranty.
% If you encountered any problems please contact the author.
% ========================================================================

function [ fname ] = ImgFileData(opt)

fname = sprintf('%s%d-%s.data.mat', opt.data_name, opt.n_class, OptionStr(opt.data_opt));
fname = [DataDir() '/' fname];
return

%% data source
dtag = sprintf('c%dn%d', length(s.cat_names), s.img_per_cat);

%% feature
switch [s.feat_type s.feat_loc]
    case 'pi'
        ftag = sprintf('pi-e%dc%d', s.ip_nedge, s.ip_ncorner);
    case 'pg'
        ftag = sprintf('pg-s%d', s.grid_step);
    case 'si'
        ftag = sprintf('si-s[%s]o%g-e%dc%d', ...
           ToStr(s.sift_scales), s.sift_orient, s.ip_nedge, s.ip_ncorner);
    case 'sg'
        ftag = sprintf('sg-s[%s]o%g-s%d', ...
            ToStr(s.sift_scales), s.sift_orient, s.grid_step);
    case 'fg'
        ftag = sprintf('fg-s[%s]-s%dt%d', ToStr(s.phow_sizes), s.grid_step, s.phow_blank_thresh*1e3);
    otherwise
        error('unknown feature type and loc');
end

fname = sprintf('%s/%s_{%s}{%s%s}.dat.mat', DataDir, s.data_name, ...
    dtag, iif(s.color, 'c', ''), ftag);
