% ========================================================================
% Liang Xiong (lxiong[at]cs[dot]cmu[dot]edu), AutonLab, 2008-2013
%
% This piece of software is free for research purposes. 
% We hope it was helpful but do not privide any warranty.
% If you encountered any problems please contact the author.
% ========================================================================

function [imgs, labels, files] = LoadImageData(data_dir, class_names, n_per_cat, sampler)
% [ imgs, labels, files ] = LoadImageData(class_names, n_per_cat, sampler)

if nargin < 3
    sampler = 'uniform';
end

n_cats = length(class_names);

imgs = cell(1, n_cats); 
files = cell(1, n_cats);
labels = cell(1, n_cats);
for ind = 1:n_cats
    [imgs{ind} files{ind}] = ReadImages([data_dir '/' class_names{ind}], ...
        struct('sz',[256 256],'max_num',n_per_cat,'sampler',sampler));
    labels{ind} = ones(length(imgs{ind}), 1)*ind;
    
    fprintf('%d images loaded from category [%s].\n', ...
        length(imgs{ind}), class_names{ind});
end

imgs = CatVec(imgs);
files = CatVec(files);
labels = CatVec(labels);
