% ========================================================================
% Liang Xiong (lxiong[at]cs[dot]cmu[dot]edu), AutonLab, 2008-2013
%
% This piece of software is free for research purposes. 
% We hope it was helpful but do not privide any warranty.
% If you encountered any problems please contact the author.
% ========================================================================

function [ y, accs, prob ] = SVMClaKM( KM, trI, teI, labels, c, verbose)
% [ y ] = SVMClaKM( KM, trI, teI, labels)

if nargin < 6
    verbose = false;
end

labels = labels(:);
KM = double(KM);
trI = L2I(trI);
teI = L2I(teI);
trN = length(trI);
teN = length(teI);

options = [iif(verbose,'','-q ') '-m 512 -s 0 -t 4 -c ' num2str(c)];
model = svmtrain(labels(trI), [(1:trN)', KM(trI, trI)], options);
[y, accs, prob] = svmpredict(labels(teI), [(1:teN)', KM(teI, trI)], model, '');
