% ========================================================================
% Liang Xiong (lxiong[at]cs[dot]cmu[dot]edu), AutonLab, 2008-2013
%
% This piece of software is free for research purposes. 
% We hope it was helpful but do not privide any warranty.
% If you encountered any problems please contact the author.
% ========================================================================

function [ r ] = CatMat( cs, fieldname, dim )
%[ r ] = CatMat( cs, fieldname, dim )
%CatMat assemble a field in cell array into a long matrix
% matrices are combined by columns
% if dim = 1, then cat by row

if nargin < 3
	dim = 1;
	if nargin < 2
		fieldname = [];
	end
end

if ~isempty(fieldname)
    cs = map(@(x) x.(fieldname), cs);
end

r = cat(dim, cs{:});
