% ========================================================================
% Liang Xiong (lxiong[at]cs[dot]cmu[dot]edu), AutonLab, 2008-2013
%
% This piece of software is free for research purposes. 
% We hope it was helpful but do not privide any warranty.
% If you encountered any problems please contact the author.
% ========================================================================

function [D] = ChiDist(A, B)
% [D] = ChiSqDist(A, B) 
% compute the chi distance (square-root of
% the chi-squared distance) between histograms
% each row is a histogram

if nargin < 2
    B = A;
end

[m d] = size(A);
n = size(B, 1);

D = nan(m, n);
for jnd = 1:n
    b = B(jnd, :);
    D(:,jnd) = sum((bsxfun(@plus, A, -b).^2)./bsxfun(@plus, A, b+eps), 2);
end
D = sqrt(0.5*D);
