% ========================================================================
% Liang Xiong (lxiong[at]cs[dot]cmu[dot]edu), AutonLab, 2008-2013
%
% This piece of software is free for research purposes. 
% We hope it was helpful but do not privide any warranty.
% If you encountered any problems please contact the author.
% ========================================================================

function [ r ] = EffectiveRank(e, thresh)
%[ r ] = EffectiveRank(e,thresh)
% EffectiveRank get the effective rank of an eigenvalue array
% if use singular values it must be squared first

if nargin < 2
    thresh = 0.99;
end
if ~isempty(strfind(class(thresh), 'int'))
    r = double(thresh);
    return;
end

assert(all(e > -1e-7), 'not a proper eigenvalue array');
e(e < 0) = 0;

e = sort(e,'descend');
ce = cumsum(e);
if ce(end) < eps
    error('excelly:EffectiveRank:e','EffecctiveRank has encounted a zero matrix');
else
    r = sum(ce./ce(end) <= thresh) + 1;
    r = min(length(e), r);
end
