% ========================================================================
% Liang Xiong (lxiong[at]cs[dot]cmu[dot]edu), AutonLab, 2008-2013
%
% This piece of software is free for research purposes. 
% We hope it was helpful but do not privide any warranty.
% If you encountered any problems please contact the author.
% ========================================================================

function [ To ] = FillMat( To, From, idx, dim )
%[ To ] = FillMat( To, From, idx, dim )
%   To(idx,:) = From. unfilled entries are nan

if nargin < 4
    dim = 1;
end
if islogical(idx)
    idx = L2I(idx);
end

if dim == 1
    assert(size(From,1) == length(idx), 'From - idx not consistent');
    if isempty(To)
        if iscell(From)
            To = cell(max(idx), size(From, 2));
        else
            To = nan(max(idx), size(From,2));
        end
    end
    To(idx, :) = From;
else
    assert(size(From,2) == length(idx));
    if iscell(From)
        To = cell(size(From,1), max(idx));
    else
        To = nan(size(From,1), max(idx));
    end
    To(:, idx) = From;
end
