% ========================================================================
% Liang Xiong (lxiong[at]cs[dot]cmu[dot]edu), AutonLab, 2008-2013
%
% This piece of software is free for research purposes. 
% We hope it was helpful but do not privide any warranty.
% If you encountered any problems please contact the author.
% ========================================================================

function [varargout]=GetOptions(options, varargin)
%[varargout] = GetOptions(options, varargin)
% process options given in a struct
% usage: [param_1, ...]=GetOptions(options_struct, 'param_1', param_1_default_value, ...)

if isempty(options)
    options = struct('no_way_you_can_use_this',[]);
end

if nargin == 2
    option_names = varargin{1};
    n = length(option_names);
    if nargout > n; error('too many output'); end
    
    for ind=1:n
        varargout{ind} = options.(option_names{ind});
    end
else
    list = varargin;
    option_names = list(1:2:end);
    option_defaults = list(2:2:end);
    
    if length(option_names) ~= length(option_defaults); 
        error('parameter input not right'); 
    end
    if ~iscellstr(option_names); 
        error('parameter list not right'); 
    end

    n = length(option_names);
    if nargout > n; 
        error('too many output'); 
    end
    
    varargout = option_defaults;
    for ind=1:n
        if isfield(options, option_names{ind})
            varargout{ind}=options.(option_names{ind});
        end
    end
end
