% ========================================================================
% Liang Xiong (lxiong[at]cs[dot]cmu[dot]edu), AutonLab, 2008-2013
%
% This piece of software is free for research purposes. 
% We hope it was helpful but do not privide any warranty.
% If you encountered any problems please contact the author.
% ========================================================================

function [ names ] = ListFiles( filter )
%[ names ] = ListFiles( folder, filter )
%   list files in folder with filter. return absolute paths

folder = fileparts(filter);
if isempty(folder)
    folder = pwd;
else
    folder = what(folder);
    folder = folder.path; % absolute path
end
folder = strrep(folder,'/./','/');

files = dir(filter);

names = map(@(f) fullfile(folder, f.name), files);
