% ========================================================================
% Liang Xiong (lxiong[at]cs[dot]cmu[dot]edu), AutonLab, 2008-2013
%
% This piece of software is free for research purposes. 
% We hope it was helpful but do not privide any warranty.
% If you encountered any problems please contact the author.
% ========================================================================

function [ str ] = OptionStr( options )
% [ str ] = OptionStr( options )
% return a string representation of options

names = fieldnames(options);
str = cell(1, length(names));
for ind = 1:length(names)
    name = GetAcronym(names{ind});
    val = options.(names{ind});
    if isstruct(val)
        val = OptionStr(val);
    else
        val = ToStr(val);
    end
    
    if ind > 1
        str{ind} = [',' sprintf('%s=%s', name, val)];
    else
        str{ind} = sprintf('%s=%s', name, val);
    end
end
str = ['{' strcat(str{:}) '}'];

function [b] = GetAcronym(name)

parts = regexp(name, '_', 'split');
b = cell(1, length(parts));
for ind = 1:length(parts)
    p = parts{ind};
    b{ind} = p(1);
end
b = strcat(b{:});
