% ========================================================================
% Liang Xiong (lxiong[at]cs[dot]cmu[dot]edu), AutonLab, 2008-2013
%
% This piece of software is free for research purposes. 
% We hope it was helpful but do not privide any warranty.
% If you encountered any problems please contact the author.
% ========================================================================

function [idx] = RI(n, max_idx, replace, sorted)
%[idx] = RI(n, max_idx, replace, sorted)
% get some random index
% n: number of index to select. if < 1, then it's the percentage
% max_idx: numel of the array, or the arry itself.
% replace: sampling with replacement. default false
% sorted: sort the indeces or not. default false

if nargin < 4
    sorted = false;
    if nargin < 3
        replace = false;
    end
end
if n < 1
    n = ceil(n*max_idx);
end

if ~replace && n > 1
    idx = randperm(max_idx);
    idx = idx(1:min(n,numel(idx)))';
else
    idx = floor(rand(n,1)*max_idx) + 1;
end

if sorted
    idx = sort(idx);
end
