% ========================================================================
% Liang Xiong (lxiong[at]cs[dot]cmu[dot]edu), AutonLab, 2008-2013
%
% This piece of software is free for research purposes. 
% We hope it was helpful but do not privide any warranty.
% If you encountered any problems please contact the author.
% ========================================================================

function [] = SetAxis(h, xlab, ylab, xlimit, ylimit, ...
                      xticks, xtick_labels, yticks, ytick_labels)
% [] = SetAxis(h, xlab, ylab, xlim, ylim, ...
%              xticks, xtick_labels, yticks, ytick_labels)

if ~exist('ytick_labels','var'); ytick_labels = []; end
if ~exist('yticks','var'); yticks = []; end
if ~exist('xtick_labels','var'); xtick_labels = []; end
if ~exist('xticks','var'); xticks = []; end
if ~exist('ylimit','var'); ylimit = []; end
if ~exist('xlimit','var'); xlimit = []; end
if ~exist('ylab','var'); ylab = []; end
if ~exist('xlab','var'); xlab = []; end

if isempty(h); h = gca; end

if ~isempty(xlab); xlabel(h, xlab); end
if ~isempty(ylab); ylabel(h, ylab); end

if ~isempty(xlimit); xlim(h, xlimit); end
if ~isempty(ylimit); ylim(h, ylimit); end

if ~isempty(xticks) || ~isempty(xtick_labels)
    if isempty(xticks); xticks = 1:length(xtick_labels); end
    
    set(h, 'XTick', xticks);
    if ~isempty(xtick_labels); set(h, 'XTickLabel', xtick_labels); end
end

if ~isempty(yticks) || ~isempty(ytick_labels)
    if isempty(yticks); yticks = 1:length(ytick_labels); end
    
    set(h, 'YTick', yticks);
    if ~isempty(ytick_labels); set(h, 'YTickLabel', ytick_labels); end
end
