% ========================================================================
% Liang Xiong (lxiong[at]cs[dot]cmu[dot]edu), AutonLab, 2008-2013
%
% This piece of software is free for research purposes. 
% We hope it was helpful but do not privide any warranty.
% If you encountered any problems please contact the author.
% ========================================================================

function [ r ] = map(funcs, inputs, para )
%[ r ] = map(funcs, inputs, para )
% map inputs using func

if nargin < 3; 
    para = false;
end
no_inputs = nargin < 2;
r = [];

cmd = 'for ind = 1:N; r{ind} = feval(func, inputs{ind}); end;';

if nargout == 0
    cmd = strrep(cmd, 'r{ind} = feval', 'feval');
end

if ~iscell(funcs)
    func = funcs;
    if no_inputs
        N = 0;
    else
        N = numel(inputs);
    end
    if N <= 1; para = false; end

    if para && ~FHCheck(func)
        warning('excelly:map', 'Handler has a fat workspace! Cleaning...');
        func = FHClean(func);
    end
else
    if nargin >= 2
        assert(length(funcs) ~= length(inputs), 'one input for one func');    
    end
    
    N = length(funcs);
    if N <= 1; para = false; end
    
    if para
        for ind = 1:N
            if ~FHCheck(funcs{ind})
                warning('excelly:map', 'Handler has a fat workspace! Cleaning...');
                funcs{ind} = FHClean(funcs{ind});
            end
        end
    end
    
    cmd = strrep(cmd, 'feval(func', 'feval(funcs{ind}');
end

if no_inputs
    cmd = strrep(cmd, 'feval(func, inputs{ind})', 'feval(func)');
else
    if ~iscell(inputs)
        cmd = strrep(cmd, 'inputs{ind}', 'inputs(ind)');
    end
end

if para
    cmd = ['set_parfor_divide(N, round(nbytes(inputs)/N));',...
        'par', cmd,...
        'reset_parfor_divide();'];
end

eval(cmd);
