% ========================================================================
% Liang Xiong (lxiong[at]cs[dot]cmu[dot]edu), AutonLab, 2008-2013
%
% This piece of software is free for research purposes. 
% We hope it was helpful but do not privide any warranty.
% If you encountered any problems please contact the author.
% ========================================================================

function [C] = scale(A, s, dim)
% scale(A, s, dim)
% scale columns (dim = 1)/rows(dim = 2) by s

if nargin < 3
    dim = 1;
    if nargin < 2
        s = [];
    end
end

if isempty(s)
    s = 1./full(sum(A, dim));
else
    s = full(s);
end
s(isinf(s)) = 1;

assert(dim >= 1 & dim <= 2, 'dim wrong');
if issparse(A)
    if dim == 1
        C = A*spdiag(s);
    else 
        C = spdiag(s)*A;
    end
else
    if dim == 1
        C = bsxfun(@times, A, s(:)');
    else
        C = bsxfun(@times, A, s(:));
    end
end
