% ========================================================================
% Liang Xiong (lxiong[at]cs[dot]cmu[dot]edu), AutonLab, 2008-2013
%
% This piece of software is free for research purposes. 
% We hope it was helpful but do not privide any warranty.
% If you encountered any problems please contact the author.
% ========================================================================

function [C]=shift(A, m, dim)
% [C]=shift(A, m, dim)
% shift rows(dim = 2) or columns (dim = 1) of A by m

if nargin < 3
    dim = 1;
    if nargin < 2
        m = [];
    end
end

if isempty(m)
    m = -mean(A, dim);
end

assert(dim >= 1 & dim <= 2, 'wrong dim');
if dim == 1
    C = bsxfun(@plus, A, m(:)');
else
    C = bsxfun(@plus, A, m(:));
end
